/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.veranstaltung.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.veranstaltung.entity.Veranstaltung;
import de.ivu.elect.business.veranstaltung.entity.VeranstaltungUK;

public abstract class AbstractVeranstaltungDAO extends de.ivu.elect.jee.entity.AbstractDAO<Veranstaltung,
        de.ivu.elect.business.veranstaltung.entity.VeranstaltungPK
    , VeranstaltungUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractVeranstaltungDAO.class);

  public AbstractVeranstaltungDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.veranstaltung.entity.VeranstaltungPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public Veranstaltung findByPrimaryKey(
        de.ivu.elect.business.veranstaltung.entity.VeranstaltungPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected Veranstaltung findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(Veranstaltung.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: GebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Veranstaltung o WHERE o.gebiet=?1<br>
      * SQL: <br>
      */
     public java.util.List<Veranstaltung> findByGebiet( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("VERANSTALTUNG.Gebiet")
                              .setParameter(1, gebietCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByGebiet - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Veranstaltung, findByGebiet - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByGebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: UkNurWahlNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Veranstaltung o WHERE o.externeId = ?1 AND o.gebiet.nummer = ?2 AND o.gebiet.gebietsart.name = ?3 AND o.gebiet.wahl.wahlart.name = ?4 AND o.gebiet.wahl.wahltermin.wahldatum = ?5 AND o.wahl.wahlart.name = ?4 AND o.wahl.wahltermin.wahldatum = ?5<br>
      * SQL: <br>
      */
     public java.util.List<Veranstaltung> findByUkNurWahl( @javax.annotation.Nonnull String externeId,  @javax.annotation.Nonnull String gebietNummer,  @javax.annotation.Nonnull String gebietsartName,  @javax.annotation.Nonnull String wahlartName,  @javax.annotation.Nonnull java.util.Date wahldatum) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  String externeIdCheckedAndAttached =  checkAndAttach(externeId, String.class, "externeId"); ;
		  			  String gebietNummerCheckedAndAttached =  checkAndAttach(gebietNummer, String.class, "gebietNummer"); ;
		  			  String gebietsartNameCheckedAndAttached =  checkAndAttach(gebietsartName, String.class, "gebietsartName"); ;
		  			  String wahlartNameCheckedAndAttached =  checkAndAttach(wahlartName, String.class, "wahlartName"); ;
		  			  java.util.Date wahldatumCheckedAndAttached =  wahldatum ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("VERANSTALTUNG.UkNurWahl")
                              .setParameter(1, externeIdCheckedAndAttached)
                                        .setParameter(2, gebietNummerCheckedAndAttached)
                                        .setParameter(3, gebietsartNameCheckedAndAttached)
                                        .setParameter(4, wahlartNameCheckedAndAttached)
                                        .setParameter(5, wahldatumCheckedAndAttached, javax.persistence.TemporalType.TIMESTAMP)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Veranstaltung, findByUkNurWahl - NonUniqueResultException, Parameter: "
           + ", externeId:'"+externeId+"'"
           + ", gebietNummer:'"+gebietNummer+"'"
           + ", gebietsartName:'"+gebietsartName+"'"
           + ", wahlartName:'"+wahlartName+"'"
           + ", wahldatum:'"+wahldatum+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByUkNurWahl(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: UkNurWahlterminNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Veranstaltung o WHERE o.externeId = ?1 AND o.gebiet.nummer = ?2 AND o.gebiet.gebietsart.name = ?3 AND o.gebiet.wahltermin.wahldatum = ?4 AND o.wahltermin.wahldatum = ?4<br>
      * SQL: <br>
      */
     public java.util.List<Veranstaltung> findByUkNurWahltermin( @javax.annotation.Nonnull String externeId,  @javax.annotation.Nonnull String gebietNummer,  @javax.annotation.Nonnull String gebietsartName,  @javax.annotation.Nonnull java.util.Date wahldatum) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  String externeIdCheckedAndAttached =  checkAndAttach(externeId, String.class, "externeId"); ;
		  			  String gebietNummerCheckedAndAttached =  checkAndAttach(gebietNummer, String.class, "gebietNummer"); ;
		  			  String gebietsartNameCheckedAndAttached =  checkAndAttach(gebietsartName, String.class, "gebietsartName"); ;
		  			  java.util.Date wahldatumCheckedAndAttached =  wahldatum ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("VERANSTALTUNG.UkNurWahltermin")
                              .setParameter(1, externeIdCheckedAndAttached)
                                        .setParameter(2, gebietNummerCheckedAndAttached)
                                        .setParameter(3, gebietsartNameCheckedAndAttached)
                                        .setParameter(4, wahldatumCheckedAndAttached, javax.persistence.TemporalType.TIMESTAMP)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Veranstaltung, findByUkNurWahltermin - NonUniqueResultException, Parameter: "
           + ", externeId:'"+externeId+"'"
           + ", gebietNummer:'"+gebietNummer+"'"
           + ", gebietsartName:'"+gebietsartName+"'"
           + ", wahldatum:'"+wahldatum+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByUkNurWahltermin(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlOrderByBeginnNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Veranstaltung o WHERE o.wahl = ?1 ORDER BY o.beginn<br>
      * SQL: <br>
      */
     public java.util.List<Veranstaltung> findByWahlOrderByBeginn( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("VERANSTALTUNG.WahlOrderByBeginn")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Veranstaltung, findByWahlOrderByBeginn - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlOrderByBeginn(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlUndGebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Veranstaltung o WHERE o.wahl=?1 AND o.gebiet=?2<br>
      * SQL: <br>
      */
     public java.util.List<Veranstaltung> findByWahlUndGebiet( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("VERANSTALTUNG.WahlUndGebiet")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, gebietCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Veranstaltung, findByWahlUndGebiet - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", gebiet:'"+gebiet+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlUndGebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminOrderByBeginnNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Veranstaltung o WHERE o.wahltermin = ?1 ORDER BY o.beginn<br>
      * SQL: <br>
      */
     public java.util.List<Veranstaltung> findByWahlterminOrderByBeginn( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("VERANSTALTUNG.WahlterminOrderByBeginn")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Veranstaltung, findByWahlterminOrderByBeginn - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlterminOrderByBeginn(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminUndGebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Veranstaltung o WHERE o.wahltermin=?1 AND o.gebiet=?2<br>
      * SQL: <br>
      */
     public java.util.List<Veranstaltung> findByWahlterminUndGebiet( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("VERANSTALTUNG.WahlterminUndGebiet")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                        .setParameter(2, gebietCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Veranstaltung, findByWahlterminUndGebiet - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
           + ", gebiet:'"+gebiet+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlterminUndGebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.veranstaltung.entity.VeranstaltungUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.veranstaltung.entity.VeranstaltungUK uk,
        de.ivu.elect.business.veranstaltung.entity.VeranstaltungPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.veranstaltung.entity.Veranstaltung findByUK(de.ivu.elect.business.veranstaltung.entity.VeranstaltungUK uk){

    try {
     return (de.ivu.elect.business.veranstaltung.entity.Veranstaltung) getEntityManager().createNamedQuery("VERANSTALTUNG.UK")
                  .setParameter(1, uk
                .getExterneId ()

              )
             .setParameter(2, uk
                .getGebietUK ()

                .getNummer ()

              )
             .setParameter(3, uk
                .getGebietUK ()

                .getGebietsartUK ()

                .getName ()

              )
             .setParameter(4, uk
                .getGebietUK ()

                .getGebietsartUK ()

                .getMandantUK ()

                .getNummer ()

              )
             .setParameter(5, uk
                .getGebietUK ()

                .getWahlUK ()

                .getWahlartUK ()

                .getName ()

              )
             .setParameter(6, uk
                .getGebietUK ()

                .getWahlUK ()

                .getWahlartUK ()

                .getMandantUK ()

                .getNummer ()

              )
             .setParameter(7, uk
                .getGebietUK ()

                .getWahlUK ()

                .getWahlterminUK ()

                .getNummer ()

              )
             .setParameter(8, uk
                .getGebietUK ()

                .getWahlUK ()

                .getWahlterminUK ()

                .getWahldatum ()

              )
             .setParameter(9, uk
                .getGebietUK ()

                .getWahlUK ()

                .getWahlterminUK ()

                .getMandantUK ()

                .getNummer ()

              )
             .setParameter(10, uk
                .getGebietUK ()

                .getWahlterminUK ()

                .getNummer ()

              )
             .setParameter(11, uk
                .getGebietUK ()

                .getWahlterminUK ()

                .getWahldatum ()

              )
             .setParameter(12, uk
                .getGebietUK ()

                .getWahlterminUK ()

                .getMandantUK ()

                .getNummer ()

              )
             .setParameter(13, uk
                .getWahlUK ()

                .getWahlartUK ()

                .getName ()

              )
             .setParameter(14, uk
                .getWahlUK ()

                .getWahlartUK ()

                .getMandantUK ()

                .getNummer ()

              )
             .setParameter(15, uk
                .getWahlUK ()

                .getWahlterminUK ()

                .getNummer ()

              )
             .setParameter(16, uk
                .getWahlUK ()

                .getWahlterminUK ()

                .getWahldatum ()

              )
             .setParameter(17, uk
                .getWahlUK ()

                .getWahlterminUK ()

                .getMandantUK ()

                .getNummer ()

              )
             .setParameter(18, uk
                .getWahlterminUK ()

                .getNummer ()

              )
             .setParameter(19, uk
                .getWahlterminUK ()

                .getWahldatum ()

              )
             .setParameter(20, uk
                .getWahlterminUK ()

                .getMandantUK ()

                .getNummer ()

              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("Veranstaltung, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}